// FORMAOPOSITORES - STUDENT

const electron = require('electron');
const PDFWindow = require('ht-pdf-window')

// Copy Pasta OFF para todas las aplicaciones mientras este abierta la aplicación
const { shell, app, BrowserWindow, globalShortcut, session, Menu } = electron;

// HOMEPAGE
const HOMEPAGE = 'https://ces2.nebulo.se/login/index.php'

// USERAGENT
const USERAGENT = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/79.0.3945.117 Safari/537.36';
//const USERAGENT = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.4044.92 Safari/537.36';

app.setName("Aula Forma Opositores");

app.on('ready', () => {

    // Ctrl+C OFF para todas las aplicaciones mientras este abierta la aplicación
    const ret = globalShortcut.register('CommandOrControl+C', () => {
        console.log('CommandOrControl+C is pressed')
    })
    
    // Ctrl+V OFF para todas las aplicaciones mientras este abierta la aplicación
    const ret2 = globalShortcut.register('CommandOrControl+V', () => {
        console.log('CommandOrControl+V is pressed')
    })
    
    // Imp Pnt OFF para todas las aplicaciones mientras este abierta la aplicación
    const ret3 = globalShortcut.register('Command+Shift+3', () => {
        console.log('PrintScreen is pressed')
    })
    const ret4 = globalShortcut.register('PrintScreen', () => {
        console.log('PrintScreen is pressed')
    })

    window = new BrowserWindow({
        width: 1200,
        height: 900,
        icon: 'logo.icns',
        webPreferences: {
            nodeIntegration: false,
            plugins: true,
            // DEBUG: comentar o descomentar
            devTools: false,
            navigateOnDragDrop: false,
            title: 'Aula Forma Opositores'
        }
    });

    // Menu
    window.setMenuBarVisibility(true);
    const menuTemplate = [
        {
            name: 'Aula',
            title: 'Aula',
            label: 'Aula',
            submenu: [
                { role: 'quit' }
            ]
        }
    ]
    const menu = Menu.buildFromTemplate(menuTemplate);
    Menu.setApplicationMenu(menu);

    window.setContentProtection(true);
    
    // Main
    window.loadURL(HOMEPAGE);

    window.webContents.on('did-finish-load', function() {
        window.setTitle('Forma Opositores v1.2');

        // No seleccionar texto
        window.webContents.insertCSS(':not(input):not(textarea), :not(input):not(textarea)::after, :not(input):not(textarea)::before { -webkit-user-select: none; user-select: none; cursor: default; }');
        window.webContents.insertCSS('input, button, textarea, :focus { outline: none; // You should add some other style for :focus to help UX/a11y ');

        // Fuera area personal de menu superior
        window.webContents.insertCSS('.item-dashboard { display: none !important; } ');
        
        // Fuera area personal de menu de navegación
        window.webContents.insertCSS('.type_setting { display: none !important; } ');
        
        // Fuera parte de abajo de la ventana Dashboard
        window.webContents.insertCSS('.student-panel-b { display: none !important; } ');

        // Fuera palabra restringido de las actividades
        window.webContents.insertCSS('.availabilityinfo .isrestricted .isfullinfo .badge .badge-info { width: 1px; color: #17a2b8; font-size: 0px; } ');
    });

    window.webContents.on('did-navigate', () => {
        window.webContents.once('dom-ready', () => {
            window.webContents.executeJavaScript(`
                // ----------------------------------------------------------------------------------------------------
                // PRINT SCREEN: desactivar boton imprimir pantalla. En cualquier caso es imposible desactivar aplicaciones externas
                // ----------------------------------------------------------------------------------------------------
                function copyToClipboard() { 
                    var aux = document.createElement("input"); 
                    aux.setAttribute("value", "No puede capturar imagenes."); 
                    document.body.appendChild(aux); 
                    aux.select(); 
                    document.execCommand("copy"); 
                    document.body.removeChild(aux); 
                    alert("¡Imprimir Pantalla está deshabilitado!"); 
                }

                // Cuando se detecta la tecla 44 (printScreen) ejecutamos la función copyToClipboard()
                window.addEventListener("keyup", function (e) {
                    if (e.keyCode == 44) {
                        copyToClipboard();
                    }
                });

				// ----------------------------------------------------------------------------------------------------
                // FOCUS
                // ----------------------------------------------------------------------------------------------------
                focusWarning = document.createElement('div');
                focusWarning.setAttribute('id', 'focusWarning');
                focusWarning.style.cssText = 'font-size:16px; text-align:center; display:block; position:absolute; top:5%; left:5%; background:#e9e9e9; width:90%; height:90%; z-index:100; ';
                focusWarning.innerHTML = "<img src='/pix/logo-web.jpg' title='Forma Opositores' style='margin-top:150px; margin-bottom:50px;'><p>Desde Forma Opositores queremos proporcionarte la mejor experiencia de formación</p><br><br><p>Vuelve a <b>hacer click en esta ventana</b> cuando estés listo y tu atención se centre en lo realmente importante</p>";
                focusWarning.style.display = "none";
                document.body.appendChild(focusWarning);
                
                // cuando la ventana tiene el foco, se muestra su contenido
                window.addEventListener("focus", function() {
                    document.getElementById("focusWarning").style.display = "none";
                });
                
                // cuando se pierde el foco de la ventana, se oculta el contenido (si se hace un printScreen del contenido con la ventana sin el foco, este no sea visible)
                window.addEventListener("blur", function() {
                    document.getElementById("focusWarning").style.display = "block";
                });

				// ----------------------------------------------------------------------------------------------------
                // PASSWORD EN LOGIN: mostrar contraseña en texto plano
                // ----------------------------------------------------------------------------------------------------
                function showPassword() {
                    var x = document.getElementById("password");
                    if (x.type === "password") {
                        x.type = "text";
                    } else {
                        x.type = "password";
                    }
                }
                p = document.getElementsByClassName("input-group input-group-password");
                p[0].innerHTML += "<span style='text-align:center; font-size:12px; vertical-align:middle; padding-top:8px; padding-left:8px;'><input type='checkbox' onclick='showPassword()'><br>Ver</span>"

				// ----------------------------------------------------------------------------------------------------
                // ACTIVITIES: BOOKS, QUIZ, PDF, PPT, DOC, ETC
                // 'visiblepro:' -> es una palabra reservada a profesores, lo que hacemos es quitar el texto a partir de ella para los alumnos
                // ----------------------------------------------------------------------------------------------------
                let activities = document.getElementsByClassName('activity');
                if (activities != null) {
                    for (let i = 0; i < activities.length; i++) {
                        activity = activities[i];
                        if (activity != null) {
                            var text = activity.innerText;
                            if (text.includes('visiblepro:')) {

                                // Quita el texto a partir de visiblepro: de todos los profesores
                                descs = activity.getElementsByClassName('contentafterlink');
                                if (descs != null) {
                                    for (let j = 0; j < descs.length; j++) {
                                        desc = descs[j];
                                        if (desc != null) {
                                            text = desc.innerText;
                                            k = text.indexOf('visiblepro:');
                                            desc.innerText = text.substring(0, k);
                                        }
                                    }
                                }

                                descs = activity.getElementsByClassName('contentwithoutlink');
                                if (descs != null) {
                                    for (let j = 0; j < descs.length; j++) {
                                        desc = descs[j];
                                        if (desc != null) {
                                            text = desc.innerText;
                                            k = text.indexOf('visiblepro:');
                                            desc.innerText = text.substring(0, k);
                                        }
                                    }
                                }
                            }
                        }
                    }
                }

				// ----------------------------------------------------------------------------------------------------
                // RESTRINGIDO -> PUNTO -------------------------------------------------------------------------------
                // ----------------------------------------------------------------------------------------------------
                //let badges = document.getElementsByClassName('badge-info');
                //if (badges != null) {
                //    for (let i = 0; i < badges.length; i++) {
                //        badge = badges[i];
                //        if (badge != null && badge.innerText.includes('Restringido')) {
                //            badge.innerText = '·';
                //        }
                //    }
                //}

				// ----------------------------------------------------------------------------------------------------
                // AREA PERSONAL: fuera del slide superior ------------------------------------------------------------
                // ----------------------------------------------------------------------------------------------------
                //m = document.getElementsByClassName('dropdown-item');
                //if (m != null) {
                //    m[0].hidden = true;
                //}
                //m = document.getElementsByClassName('dropdown-divider');
                //if (m != null) {
                //    m[0].hidden = true;
                //}
                
                // ----------------------------------------------------------------------------------------------------
                // BREADCUMB: fuera area personal ---------------------------------------------------------------------
                // ----------------------------------------------------------------------------------------------------
                //b = document.getElementsByClassName('breadcrumb');
                //if (b != null) {
                //    l = b[1].getElementsByTagName('li');
                //    if (l[1].outerText === " Área personal") {
                //        l[1].hidden = true;
                //    }
                //}

				// ----------------------------------------------------------------------------------------------------
                // MISCELANEA: fuera bloque de profile.php ------------------------------------------------------------
                // ----------------------------------------------------------------------------------------------------
                //m = document.getElementById('page-content');
                //if (m != null) {
                //    t = m.getElementsByTagName('H3')[3];
                //    if (t != null && t.outerText === "Miscelánea") {
                //        t.parentElement.hidden = true;
                //    }
                //}
                
                // ----------------------------------------------------------------------------------------------------
                // PREFERENCIAS: fuera opciones de preferences.php. Solo visibles: cambiar contraseña y notificaciones
                // ----------------------------------------------------------------------------------------------------
                //cards = document.getElementsByClassName('card-body');
                //if (cards != null) {
                //    c = cards[0];
                //    if (c != null) {
                //        if (c.innerText.includes('CUENTA DE USUARIO')) {
                //            p = c.getElementsByTagName('a');
                //            if (p != null) {
                //                p[0].hidden = true;
                //                p[2].hidden = true;
                //                p[3].hidden = true;
                //                p[4].hidden = true;
                //                p[5].hidden = true;
                //                p[6].hidden = true;
                //                p[7].hidden = true;
                //            }
                //        }
                //    }
                //}
            `)
        })
    });
    
    // Tampoco queremos DND
    window.webContents.on("dragover", function(e) { e.preventDefault() }); 

    // Ventanas extra
    session.defaultSession.on('will-download', (event, item, webContents) => {
        if (item.getMimeType() === 'application/pdf' && item.getURL().indexOf('blob:file:') != 0) {
            allow = item.getFilename().startsWith('d-');
            event.preventDefault();
            pdfWin = new PDFWindow({
                width: 800,
                height: 600
            })
            
            // Los ficheros que empiecen por 'd-' no tienen restricciones
            if (!allow) {
                pdfWin.webContents.on('did-finish-load', function() {
                    // No seleccionar texto en el PDF
                    pdfWin.webContents.insertCSS(':not(input):not(textarea), :not(input):not(textarea)::after, :not(input):not(textarea)::before { -webkit-user-select: none; user-select: none; cursor: default; }');
                    pdfWin.webContents.insertCSS('input, button, textarea, :focus { outline: none; ');

                    // ToolBar
                    pdfWin.webContents.insertCSS('#openFile { visibility: hidden; ');
                    pdfWin.webContents.insertCSS('#download { visibility: hidden; ');
                    pdfWin.webContents.insertCSS('#print { visibility: hidden; ');
                    pdfWin.webContents.insertCSS('#viewBookmark { visibility: hidden; ');
                    pdfWin.webContents.insertCSS('#secondaryToolbarToggle { visibility: hidden; ');
                });
            }

            pdfWin.loadURL(item.getURL());
        }
    })

    // USER AGENT
    session.defaultSession.webRequest.onBeforeSendHeaders((details, callback) => {
        details.requestHeaders['User-Agent'] = USERAGENT;
        callback({ cancel: false, requestHeaders: details.requestHeaders });
    });

    // SALIR
    window.on('closed', () => {
        window = null;
    });

    // DEBUG: comentar o descomentar
    //window.webContents.openDevTools();
});

// Ventanas secundarias que se abran desde la principal. Ej: videoconferencia
app.on('browser-window-created', function(e, w) {
    w.setTitle('Forma Opositores');
    e.preventDefault();
    w.setMenu(null);

    w.webContents.on('did-finish-load', function() {
        w.setTitle('Forma Opositores - Video Clase');
    });
});

// Handle creating/removing shortcuts on Windows when installing/uninstalling.
if (require('electron-squirrel-startup')) { // eslint-disable-line global-require
    app.quit();
}
  
// Quit when all windows are closed.
app.on('window-all-closed', () => {
    // On OS X it is common for applications and their menu bar
    // to stay active until the user quits explicitly with Cmd + Q
    if (process.platform !== 'darwin') {
      app.quit();
    }
});

// ----------------------------------------------------------------------------------------------------
// ANTI-PIRATERIA: div con el nombre de usuario
// ----------------------------------------------------------------------------------------------------

function antiPirate(w) {
    if (w == null || w.webContents == null) return;
    w.webContents.executeJavaScript(`
        userLogin = document.getElementById("actionmenuaction-1");

        // ----------------------------------------------------------------------------------------------------
        // Ventana principal de moodle
        // ----------------------------------------------------------------------------------------------------
        topMenu = document.getElementsByClassName('fixed-top');
        if (topMenu[0] != null) {
            var elem = document.getElementById("anti-pirate");
            if (elem == null) {
                var elem = document.createElement('div');
                elem.setAttribute('id', 'anti-pirate');
                elem.style.cssText = 'position:absolute; width:400px; height:60px; z-index:100; background:#e29930; color:white; font-weight: 700; font-size: 20px; top:0; left:30%; vertical-align:middle; text-align:center; display:table-cell; ';
                elem.innerHTML = '<p>Anti copia by Nebulose</p>';
                if (userLogin != null) {
                    elem.innerHTML = '<p><span style="font-weight:100; font-size: 15px;">Forma Opositores</span><br>' + userLogin.innerText + '</p>';
                }
                topMenu[0].appendChild(elem);
                // console.log('anti pirate en header');
            }
        }

        // ----------------------------------------------------------------------------------------------------
        // Videoclase Big Blue Button
        // ----------------------------------------------------------------------------------------------------
        // bbb = document.getElementById("app");
        bbb = document.getElementById("container");
        if (bbb != null) {
            // BBB actualiza el título con cada evento asi que hacemos lo mismo
            document.title = 'Forma Opositores - Video Clase'; 
            var elemBBB = document.getElementById("anti-pirate-bbb");
            if (elemBBB == null) {
                var elemBBB = document.createElement('div');
                elemBBB.setAttribute('id', 'anti-pirate-bbb');
                // elemBBB.style.cssText = "width: 117%; height: 69%; position: absolute; left: 0; top: 0; transform: rotate(130deg); text-align: center; vertical-align: middle; z-index: 100;";
                elemBBB.style.cssText = "width: 72%; height: 9%; position: absolute; left: 0%; top: 70%; transform: rotate(120deg); text-align: center; vertical-align: middle; z-index: 9; ";
                elemBBB.innerHTML = '<p style = "width: 64%; transform: rotate(-180deg); -webkit-text-stroke: 2px #eae4e4; font: normal arial, tahoma, helvetica, sans-serif; font-size: 70px; color: #ffffff00;">' + window.sessionStorage.getItem('BBB_fullname') + '</p>';
                bbb.appendChild(elemBBB);
                // console.log('anti pirate en video clase');
            } 
        }
        
        // ----------------------------------------------------------------------------------------------------
        // Grabación de Big Blue Button
        // ----------------------------------------------------------------------------------------------------
        bbr = document.getElementById("presentation-area");
        if (bbr != null) {
            // BBB actualiza el título con cada evento asi que hacemos lo mismo
            document.title = 'Forma Opositores - Grabación Video Clase'; 
        //     var elemBBR = document.getElementById("anti-pirate-bbr");
        //     if (elemBBR == null) {
        //         var elemBBR = document.createElement('div');
        //         elemBBR.setAttribute('id', 'anti-pirate-bbr');
        //         elemBBR.style.cssText = "width: 117%; height: 69%; position: absolute; left: 0; top: 0; transform: rotate(130deg); text-align: center; vertical-align: middle; z-index: 100;";
        //         // elemBBR.innerHTML = '<p style = "transform: rotate(-180deg); -webkit-text-stroke: 2px #bfbfbf; font-family: sans; font-size: 70px; color: #ffffff00;">' + window.sessionStorage.getItem('BBB_fullname') + '</p>';
        //         elemBBR.innerHTML = '<p style = "transform: rotate(-180deg); -webkit-text-stroke: 2px #bfbfbf; font-family: sans; font-size: 70px; color: #ffffff00;">' + 'Forma Opositores' + '</p>';
        //         bbr.appendChild(elemBBR);
        //         // console.log('anti pirate en grabación');
        //     } 
        }

        // ----------------------------------------------------------------------------------------------------
        // Quitar copyright de BBR
        // ----------------------------------------------------------------------------------------------------
        copyright = document.getElementById("copyright");
        if (copyright != null) {
            copyright.style.display = "none";
            // console.log('anti pirate en footer');
        }
    `)
}
